#!/usr/bin/env python3
"""
GISAS of a two-sphere compound unit cell on a hexagonal lattice.

Two spheres at the origin and at (R, R/√3, √(8/3)·R) form the basis
of a hexagonal crystal. This mimics an HCP-like stacking.
"""
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm, R3
import math


def get_sample():
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("Particle", particle_color, 6e-4, 2e-8)
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 6e-6, 2e-8)
    vacuum = ba.Vacuum()

    R = 10 * nm
    ff = ba.Sphere(R)
    sphere = ba.Particle(particle_mat, ff)

    basis = ba.Compound()
    basis.addComponents(sphere, [
        R3(0, 0, 0),
        R3(R, R / math.sqrt(3), math.sqrt(8 / 3) * R)
    ])

    lattice = ba.HexagonalLattice2D(20 * nm, 0)
    structure = ba.Crystal2D(basis, lattice)
    profile = ba.Profile2DCauchy(100 * nm, 100 * nm, 0)
    structure.setDecayFunction(profile)

    vacuum_layer = ba.Layer(vacuum)
    substrate_layer = ba.Layer(substrate_mat)
    vacuum_layer.deposit2D(structure)

    sample = ba.Sample()
    sample.addLayer(vacuum_layer)
    sample.addLayer(substrate_layer)
    return sample


<%= include_partial("template/sim/gisas_standard_wide.py") -%>


<%= include_partial("template/main/runsim_unitaspect.py",
    "ba.showSample3D(sample, sample_size=250*nm, seed=0)") -%>
